diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 107,112 ****
--- 107,124 ----
  }
  
  /**
+  * Clears the cache held by get_theme_roots() and WP_Theme.
+  *
+  * @since 3.5.0
+  */
+ function wp_clean_themes_cache() {
+ 	delete_site_transient('update_themes');
+ 	search_theme_directories( true );
+ 	foreach ( wp_get_themes( array( 'errors' => null ) ) as $theme )
+ 		$theme->cache_delete();
+ }
+ 
+ /**
   * Whether a child theme is in use.
   *
   * @since 3.0.0
***************
*** 638,652 ****
  }
  
  /**
!  * Switches current theme to new template and stylesheet names.
   *
   * @since 2.5.0
   * @uses do_action() Calls 'switch_theme' action, passing the new theme.
   *
!  * @param string $template Template name
!  * @param string $stylesheet Stylesheet name.
   */
! function switch_theme( $template, $stylesheet ) {
  	global $wp_theme_directories, $sidebars_widgets;
  
  	if ( is_array( $sidebars_widgets ) )
--- 650,666 ----
  }
  
  /**
!  * Switches the theme.
!  *
!  * Accepts one argument: $stylesheet of the theme. It also accepts an additional function signature
!  * of two arguments: $template then $stylesheet. This is for backwards compatibility.
   *
   * @since 2.5.0
   * @uses do_action() Calls 'switch_theme' action, passing the new theme.
   *
!  * @param string $stylesheet Stylesheet name
   */
! function switch_theme( $stylesheet ) {
  	global $wp_theme_directories, $sidebars_widgets;
  
  	if ( is_array( $sidebars_widgets ) )
***************
*** 654,660 ****
  
  	$old_theme  = wp_get_theme();
  	$new_theme = wp_get_theme( $stylesheet );
! 	$new_name  = $new_theme->get('Name');
  
  	update_option( 'template', $template );
  	update_option( 'stylesheet', $stylesheet );
--- 668,680 ----
  
  	$old_theme  = wp_get_theme();
  	$new_theme = wp_get_theme( $stylesheet );
! 
! 	if ( func_num_args() > 1 ) {
! 		$template = $stylesheet;
! 		$stylesheet = func_get_arg( 1 );
! 	} else {
! 		$template = $new_theme->get_template();
! 	}
  
  	update_option( 'template', $template );
  	update_option( 'stylesheet', $stylesheet );
***************
*** 662,669 ****
--- 682,694 ----
  	if ( count( $wp_theme_directories ) > 1 ) {
  		update_option( 'template_root', get_raw_theme_root( $template, true ) );
  		update_option( 'stylesheet_root', get_raw_theme_root( $stylesheet, true ) );
+ 	} else {
+ 		delete_option( 'template_root' );
+ 		delete_option( 'stylesheet_root' );
  	}
  
+ 	$new_name  = $new_theme->get('Name');
+ 
  	update_option( 'current_theme', $new_name );
  
  	if ( is_admin() && false === get_option( 'theme_mods_' . $stylesheet ) ) {
***************
*** 694,710 ****
  		return true;
  
  	if ( get_template() != WP_DEFAULT_THEME && !file_exists(get_template_directory() . '/index.php') ) {
! 		switch_theme( WP_DEFAULT_THEME, WP_DEFAULT_THEME );
  		return false;
  	}
  
  	if ( get_stylesheet() != WP_DEFAULT_THEME && !file_exists(get_template_directory() . '/style.css') ) {
! 		switch_theme( WP_DEFAULT_THEME, WP_DEFAULT_THEME );
  		return false;
  	}
  
  	if ( is_child_theme() && ! file_exists( get_stylesheet_directory() . '/style.css' ) ) {
! 		switch_theme( WP_DEFAULT_THEME, WP_DEFAULT_THEME );
  		return false;
  	}
  
--- 719,735 ----
  		return true;
  
  	if ( get_template() != WP_DEFAULT_THEME && !file_exists(get_template_directory() . '/index.php') ) {
! 		switch_theme( WP_DEFAULT_THEME );
  		return false;
  	}
  
  	if ( get_stylesheet() != WP_DEFAULT_THEME && !file_exists(get_template_directory() . '/style.css') ) {
! 		switch_theme( WP_DEFAULT_THEME );
  		return false;
  	}
  
  	if ( is_child_theme() && ! file_exists( get_stylesheet_directory() . '/style.css' ) ) {
! 		switch_theme( WP_DEFAULT_THEME );
  		return false;
  	}
  
***************
*** 869,880 ****
  	if ( is_random_header_image() )
  		$url = get_random_header_image();
  
! 	if ( is_ssl() )
! 		$url = str_replace( 'http://', 'https://', $url );
! 	else
! 		$url = str_replace( 'https://', 'http://', $url );
! 
! 	return esc_url_raw( $url );
  }
  
  /**
--- 894,900 ----
  	if ( is_random_header_image() )
  		$url = get_random_header_image();
  
! 	return esc_url_raw( set_url_scheme( $url ) );
  }
  
  /**
***************
*** 1008,1014 ****
   * @return object
   */
  function get_custom_header() {
! 	$data = is_random_header_image()? _get_random_header_data() : get_theme_mod( 'header_image_data' );
  	$default = array(
  		'url'           => '',
  		'thumbnail_url' => '',
--- 1028,1057 ----
   * @return object
   */
  function get_custom_header() {
! 	global $_wp_default_headers;
! 
! 	if ( is_random_header_image() ) {
! 		$data = _get_random_header_data();
! 	} else {
! 		$data = get_theme_mod( 'header_image_data' );
! 		if ( ! $data && current_theme_supports( 'custom-header', 'default-image' ) ) {
! 			$directory_args = array( get_template_directory_uri(), get_stylesheet_directory_uri() );
! 			$data = array();
! 			$data['url'] = $data['thumbnail_url'] = vsprintf( get_theme_support( 'custom-header', 'default-image' ), $directory_args );
! 			if ( ! empty( $_wp_default_headers ) ) {
! 				foreach ( (array) $_wp_default_headers as $default_header ) {
! 					$url = vsprintf( $default_header['url'], $directory_args );
! 					if ( $data['url'] == $url ) {
! 						$data = $default_header;
! 						$data['url'] = $url;
! 						$data['thumbnail_url'] = vsprintf( $data['thumbnail_url'], $directory_args );
! 						break;
! 					}
! 				}
! 			}
! 		}
! 	}
! 
  	$default = array(
  		'url'           => '',
  		'thumbnail_url' => '',
***************
*** 1103,1109 ****
   */
  function _custom_background_cb() {
  	// $background is the saved custom image, or the default image.
! 	$background = get_background_image();
  
  	// $color is the saved custom color.
  	// A default has to be specified in style.css. It will not be printed here.
--- 1146,1152 ----
   */
  function _custom_background_cb() {
  	// $background is the saved custom image, or the default image.
! 	$background = set_url_scheme( get_background_image() );
  
  	// $color is the saved custom color.
  	// A default has to be specified in style.css. It will not be printed here.
***************
*** 1446,1451 ****
--- 1489,1496 ----
  
  	switch ( $feature ) {
  		case 'custom-header' :
+ 			if ( false === did_action( 'wp_loaded', '_custom_header_background_just_in_time' ) )
+ 				break;
  			$support = get_theme_support( 'custom-header' );
  			if ( $support[0]['wp-head-callback'] )
  				remove_action( 'wp_head', $support[0]['wp-head-callback'] );
***************
*** 1454,1459 ****
--- 1499,1506 ----
  			break;
  
  		case 'custom-background' :
+ 			if ( false === did_action( 'wp_loaded', '_custom_header_background_just_in_time' ) )
+ 				break;
  			$support = get_theme_support( 'custom-background' );
  			remove_action( 'wp_head', $support[0]['wp-head-callback'] );
  			remove_action( 'admin_menu', array( $GLOBALS['custom_background'], 'init' ) );
***************
*** 1669,1675 ****
  			request = true;
  <?php		endif; ?>
  
! 			b[c] = b[c].replace( rcs, '' );
  			b[c] += ( window.postMessage && request ? ' ' : ' no-' ) + cs;
  		}());
  	</script>
--- 1716,1722 ----
  			request = true;
  <?php		endif; ?>
  
! 			b[c] = b[c].replace( rcs, ' ' );
  			b[c] += ( window.postMessage && request ? ' ' : ' no-' ) + cs;
  		}());
  	</script>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/update.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/update.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/update.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/update.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 155,168 ****
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
  		case 'load-update-core.php' :
! 			$timeout = 60; // 1 min
  			break;
  		case 'load-plugins.php' :
  		case 'load-update.php' :
! 			$timeout = 3600; // 1 hour
  			break;
  		default :
! 			$timeout = 43200; // 12 hours
  	}
  
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
--- 155,168 ----
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
  		case 'load-update-core.php' :
! 			$timeout = MINUTE_IN_SECONDS;
  			break;
  		case 'load-plugins.php' :
  		case 'load-update.php' :
! 			$timeout = HOUR_IN_SECONDS;
  			break;
  		default :
! 			$timeout = 12 * HOUR_IN_SECONDS;
  	}
  
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
***************
*** 264,277 ****
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
  		case 'load-update-core.php' :
! 			$timeout = 60; // 1 min
  			break;
  		case 'load-themes.php' :
  		case 'load-update.php' :
! 			$timeout = 3600; // 1 hour
  			break;
  		default :
! 			$timeout = 43200; // 12 hours
  	}
  
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
--- 264,277 ----
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
  		case 'load-update-core.php' :
! 			$timeout = MINUTE_IN_SECONDS;
  			break;
  		case 'load-themes.php' :
  		case 'load-update.php' :
! 			$timeout = HOUR_IN_SECONDS;
  			break;
  		default :
! 			$timeout = 12 * HOUR_IN_SECONDS;
  	}
  
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
***************
*** 279,286 ****
  	if ( $time_not_changed ) {
  		$theme_changed = false;
  		foreach ( $checked as $slug => $v ) {
- 			$update_request->checked[ $slug ] = $v;
- 
  			if ( !isset( $last_update->checked[ $slug ] ) || strval($last_update->checked[ $slug ]) !== strval($v) )
  				$theme_changed = true;
  		}
--- 279,284 ----
***************
*** 354,370 ****
  	}
  
  	$counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'];
! 	$update_title = array();
  	if ( $counts['wordpress'] )
! 		$update_title[] = sprintf(__('%d WordPress Update'), $counts['wordpress']);
  	if ( $counts['plugins'] )
! 		$update_title[] = sprintf(_n('%d Plugin Update', '%d Plugin Updates', $counts['plugins']), $counts['plugins']);
  	if ( $counts['themes'] )
! 		$update_title[] = sprintf(_n('%d Theme Update', '%d Theme Updates', $counts['themes']), $counts['themes']);
  
! 	$update_title = ! empty( $update_title ) ? esc_attr( implode( ', ', $update_title ) ) : '';
  
! 	return array( 'counts' => $counts, 'title' => $update_title );
  }
  
  function _maybe_update_core() {
--- 352,368 ----
  	}
  
  	$counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'];
! 	$titles = array();
  	if ( $counts['wordpress'] )
! 		$titles['wordpress'] = sprintf( __( '%d WordPress Update'), $counts['wordpress'] );
  	if ( $counts['plugins'] )
! 		$titles['plugins'] = sprintf( _n( '%d Plugin Update', '%d Plugin Updates', $counts['plugins'] ), $counts['plugins'] );
  	if ( $counts['themes'] )
! 		$titles['themes'] = sprintf( _n( '%d Theme Update', '%d Theme Updates', $counts['themes'] ), $counts['themes'] );
  
! 	$update_title = $titles ? esc_attr( implode( ', ', $titles ) ) : '';
  
! 	return apply_filters( 'wp_get_update_data', array( 'counts' => $counts, 'title' => $update_title ), $titles );
  }
  
  function _maybe_update_core() {
***************
*** 373,379 ****
  	$current = get_site_transient( 'update_core' );
  
  	if ( isset( $current->last_checked ) &&
! 		43200 > ( time() - $current->last_checked ) &&
  		isset( $current->version_checked ) &&
  		$current->version_checked == $wp_version )
  		return;
--- 371,377 ----
  	$current = get_site_transient( 'update_core' );
  
  	if ( isset( $current->last_checked ) &&
! 		12 * HOUR_IN_SECONDS > ( time() - $current->last_checked ) &&
  		isset( $current->version_checked ) &&
  		$current->version_checked == $wp_version )
  		return;
***************
*** 392,398 ****
   */
  function _maybe_update_plugins() {
  	$current = get_site_transient( 'update_plugins' );
! 	if ( isset( $current->last_checked ) && 43200 > ( time() - $current->last_checked ) )
  		return;
  	wp_update_plugins();
  }
--- 390,396 ----
   */
  function _maybe_update_plugins() {
  	$current = get_site_transient( 'update_plugins' );
! 	if ( isset( $current->last_checked ) && 12 * HOUR_IN_SECONDS > ( time() - $current->last_checked ) )
  		return;
  	wp_update_plugins();
  }
***************
*** 408,414 ****
   */
  function _maybe_update_themes( ) {
  	$current = get_site_transient( 'update_themes' );
! 	if ( isset( $current->last_checked ) && 43200 > ( time( ) - $current->last_checked ) )
  		return;
  
  	wp_update_themes();
--- 406,412 ----
   */
  function _maybe_update_themes( ) {
  	$current = get_site_transient( 'update_themes' );
! 	if ( isset( $current->last_checked ) && 12 * HOUR_IN_SECONDS > ( time( ) - $current->last_checked ) )
  		return;
  
  	wp_update_themes();
